# TerminateInstance

## 1. API Description

This API (TerminateInstance) is used to return a virtual machine instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Use this API to return an instance that is no longer required. A pay-as-you-go instance will stop billing after it is returns.</mark>
* <mark style="color:blue;">After the instance is returned, the undetachable disks will also be returned, including system disk and additional data disk creating along with the instance. You can call</mark> [<mark style="color:purple;">`DescribeDisks`</mark>](/api-reference/compute/vm/disk/describedisks.md) <mark style="color:blue;">and find</mark> <mark style="color:blue;">`portable`</mark> <mark style="color:blue;">in the response to see whether the disk is detachable.</mark>
* <mark style="color:blue;">Instance</mark> <mark style="color:blue;">in recycle bin</mark> <mark style="color:blue;">will be shut down. Please operate with caution.</mark>
* <mark style="color:blue;">Operations on instances in recycle bin or in stalling status are not supported.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                      |
| -------------- | -------- | ------ | -------------------------------------------------------------------------------------------------------------------------------- |
| instanceId     | Yes      | String | <p>Instance ID(s).</p><p>To obtain the instance IDs, you can call DescribeInstances and look for instanceId in the response.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Return an instance with the ID of `instanceId`.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: TerminateInstance
<Common Request Params>

Request:
{
  "instanceId": "instanceId"
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                       | Description                                                                                  |
| ---------------- | ------------------------------------------------ | -------------------------------------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                    | Instance does not exist.                                                                     |
| 403              | OPERATION\_DENIED\_INSTANCE\_RECYCLED            | Operations on instances in recycle bin are not supported.                                    |
| 403              | OPERATION\_DENIED\_INSTANCE\_CREATING            | Operations on instances in `CREATING` status are not supported.                              |
| 403              | OPERATION\_DENIED\_INSTANCE\_STATUS\_INSTALLING  | Operations on instances in `INSTALLING` status are not supported.                            |
| 400              | UNSUPPORTED\_OPERATION\_INSTANCE\_CHARGE\_TYPE   | Only operations on a pay-as-you-go disk are supported.                                       |
| 403              | OPERATION\_DENIED\_POSTPAID\_PROMISE             | Operations on instances in commitment term of pay-as-you-go billing model are not supported. |
| 400              | UNSUPPORTED\_OPERATION\_INSTANCE\_BEING\_RECYCLE | Operations on instances in recycle bin are not supported.                                    |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/vm/virtual-machine-instance/terminateinstance.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
